      subroutine plzz2j(imode,isel)
      implicit none

      INCLUDE 'inclk.h'
      INCLUDE 'grchad.inc'

      INTEGER MXDIM,NDMX,NDIM,NWILD,IG,NCALL,ITMX1,ITMX2
      DOUBLE PRECISION XL,XU,ACC1,ACC2
      PARAMETER (MXDIM = 50, NDMX = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     $     IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2

      INTEGER JPROC
      COMMON /AMJPRC/JPROC

      CHARACTER GRCPROC*40
      COMMON/GRCCHAR/GRCPROC

      INTEGER i,imode,isel
      real*8  xsn(10),rna
      integer imrg,ijrg


C...Decide subprocess ID.
      if (imode.eq.1) then
         ijrg = 558
         imrg = 7
         xsn(2) = 0.20d0        ! 560
         xsn(3) = 0.30d0        ! 561
         xsn(4) = 0.50d0        ! 562
         xsn(5) = 0.70d0        ! 563
         xsn(6) = 0.80d0        ! 564
         xsn(7) = 0.90d0        ! 565
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            imrg = 6
            xsn(2) = 0.20d0     ! 560
            xsn(3) = 0.40d0     ! 562
            xsn(4) = 0.70d0     ! 563
            xsn(5) = 0.80d0     ! 564
            xsn(6) = 0.90d0     ! 565
         endif
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            imrg = 2
            xsn(2) = 0.50d0     ! 562
         endif
         rna = xrun(17)
         xsn(1) = 0.0d0
         xsn(imrg+1) = 1.0d0
         do i = 1,imrg
            if (rna.gt.xsn(i).and.rna.le.xsn(i+1)) then
               gpri(10) = (rna-xsn(i))/(xsn(i+1)-xsn(i))
               yacob = yacob/(xsn(i+1)-xsn(i))
               jproc = i + ijrg
            endif
         enddo
C...Inclusive heavy flavor production.
         if (igjflv(7).eq.0) then
            if (jproc.eq.564) jproc = 565
            if (jproc.eq.563) jproc = 564
            if (jproc.eq.562) jproc = 563
            if (jproc.eq.561) jproc = 562
         endif
         if (igjflv(1)+igjflv(2)+igjflv(3)+igjflv(4)
     $        +igjflv(5)+igjflv(7).eq.0.and.igjflv(6).eq.1) then
            if (jproc.eq.560) jproc = 562
            if (jproc.eq.559) jproc = 560
         endif

C...Set dimension and process character.
      else if (imode.eq.2) then
	 ndim = 19
         if (isel.eq.142) grcproc = 'pp(bar)->Z/A(2f)+Z/A(2f)+2jets'
         if (isel.eq.559) grcproc = 'qg -> Z/A(2f)+Z/A(2f) + qg'
         if (isel.eq.560) grcproc = 'qq -> Z/A(2f)+Z/A(2f) + qq'
         if (isel.eq.561) grcproc = 'qq -> Z/A(2f)+Z/A(2f) + gg'
         if (isel.eq.562) grcproc = 'gg -> Z/A(2f)+Z/A(2f) + qq'
         if (isel.eq.563) grcproc = 'qq -> Z/A(2f)+Z/A(2f) + qq'
         if (isel.eq.564) grcproc = 'qq -> Z/A(2f)+Z/A(2f) + qq'
         if (isel.eq.565) grcproc = 'qq -> Z/A(2f)+Z/A(2f) + qq'

C...Initialize kinematic parameter.
      else if (imode.eq.3) then
	 mxreg = 1
	 ktype = 2601
	 cxtype = 12345678
	 if (igrcgef.eq.1) then
	    gtau(1) = 1
	    gtau(14) = 2
	    gyst(1) = 1
	    gyst(14) = 1
	    gq12(1) = 2
	    gq12(2) = 10.0d0**2
	    gq12(3) = 70.0d0**2
	    gq12(9) = 0.5d0
	    gq12(14) = 3
	    gq12(15) = 11
	    gq22(1) = 2
	    gq22(2) = 10.0d0**2
	    gq22(3) = 70.0d0**2
	    gq22(9) = 0.5d0
	    gq22(14) = 3
	    gq22(15) = 11
	    gcos3(1) = 1
	    gcos3(14) = 4
	 else
	    gtau(1) = 1
	    gtau(14) = 2
	    gyst(1) = 1
	    gyst(14) = 1
	    gq12(1) = 1
	    gq12(2) = 10.0d0**2
	    gq12(14) = 11
	    gq22(1) = 1
	    gq22(2) = 10.0d0**2
	    gq22(14) = 11
	    gcos3(1) = 1
	    gcos3(14) = 4
	 endif

C...Set flavor and if necessary, decide weight of each phase space.
      else if (imode.eq.4) then
         isel = 1
      endif

      return
      end
